diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -21238,7 +24979,7 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x1F, 0x0C42);
                 ClearAndSetEthPhyBit(sc,
                                      0x11,
-                                     BIT_13 ,
+                                     BIT_13,
                                      BIT_14
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21282,7 +25023,7 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x1F, 0x0C42);
                 ClearAndSetEthPhyBit(sc,
                                      0x11,
-                                     BIT_13 ,
+                                     BIT_13,
                                      BIT_14
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21291,49 +25032,49 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x13, 0x80F3);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x8B00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80F0);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x3A00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80EF);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x0500
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80F6);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x6E00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80EC);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x6800
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80ED);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x7C00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80F2);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xF400
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80F4);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x8500
                                     );
 
@@ -21341,49 +25082,49 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x13, 0x8110);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xA800
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x810F);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x1D00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x8111);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xF500
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x8113);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x6100
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x8115);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x9200
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x810E);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x0400
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x810C);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x7C00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x810B);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x5A00
                                     );
 
@@ -21391,31 +25132,31 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x13, 0x80D1);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xFF00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80CD);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x9E00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80D3);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x0E00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80D5);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xCA00
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80D7);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x8400
                                     );
 
@@ -21572,103 +25313,29 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x0C, PhyRegValue);
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
         } else if (sc->re_type == MACFG_68) {
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                PhyRegValue |= BIT_4;
-                MP_WritePhyUshort(sc,0x10, PhyRegValue);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0B80);
-                WaitCnt = 0;
-                do {
-                        PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                        PhyRegValue &= 0x0040;
-                        DELAY(50);
-                        DELAY(50);
-                        WaitCnt++;
-                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x8028);
-                MP_WritePhyUshort(sc,0x14, 0x6200);
-                MP_WritePhyUshort(sc,0x13, 0xB82E);
-                MP_WritePhyUshort(sc,0x14, 0x0001);
-
-                MP_WritePhyUshort(sc, 0x1F, 0x0A43);
-                MP_WritePhyUshort(sc, 0x13, 0xB820);
-                MP_WritePhyUshort(sc, 0x14, 0x0290);
-                MP_WritePhyUshort(sc, 0x13, 0xA012);
-                MP_WritePhyUshort(sc, 0x14, 0x0000);
-                MP_WritePhyUshort(sc, 0x13, 0xA014);
-                MP_WritePhyUshort(sc, 0x14, 0x2c04);
-                MP_WritePhyUshort(sc, 0x14, 0x2c10);
-                MP_WritePhyUshort(sc, 0x14, 0x2c10);
-                MP_WritePhyUshort(sc, 0x14, 0x2c10);
-                MP_WritePhyUshort(sc, 0x14, 0xa210);
-                MP_WritePhyUshort(sc, 0x14, 0xa101);
-                MP_WritePhyUshort(sc, 0x14, 0xce10);
-                MP_WritePhyUshort(sc, 0x14, 0xe070);
-                MP_WritePhyUshort(sc, 0x14, 0x0f40);
-                MP_WritePhyUshort(sc, 0x14, 0xaf01);
-                MP_WritePhyUshort(sc, 0x14, 0x8f01);
-                MP_WritePhyUshort(sc, 0x14, 0x183e);
-                MP_WritePhyUshort(sc, 0x14, 0x8e10);
-                MP_WritePhyUshort(sc, 0x14, 0x8101);
-                MP_WritePhyUshort(sc, 0x14, 0x8210);
-                MP_WritePhyUshort(sc, 0x14, 0x28da);
-                MP_WritePhyUshort(sc, 0x13, 0xA01A);
-                MP_WritePhyUshort(sc, 0x14, 0x0000);
-                MP_WritePhyUshort(sc, 0x13, 0xA006);
-                MP_WritePhyUshort(sc, 0x14, 0x0017);
-                MP_WritePhyUshort(sc, 0x13, 0xA004);
-                MP_WritePhyUshort(sc, 0x14, 0x0015);
-                MP_WritePhyUshort(sc, 0x13, 0xA002);
-                MP_WritePhyUshort(sc, 0x14, 0x0013);
-                MP_WritePhyUshort(sc, 0x13, 0xA000);
-                MP_WritePhyUshort(sc, 0x14, 0x18d1);
-                MP_WritePhyUshort(sc, 0x13, 0xB820);
-                MP_WritePhyUshort(sc, 0x14, 0x0210);
-
-                MP_WritePhyUshort(sc,0x1F, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x0000);
-                MP_WritePhyUshort(sc,0x14, 0x0000);
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x17);
-                PhyRegValue &= ~(BIT_0);
-                MP_WritePhyUshort(sc,0x17, PhyRegValue);
-                MP_WritePhyUshort(sc,0x1f, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x8028);
-                MP_WritePhyUshort(sc,0x14, 0x0000);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                PhyRegValue &= ~(BIT_4);
-                MP_WritePhyUshort(sc,0x10, PhyRegValue);
-
-
-
                 MP_WritePhyUshort(sc, 0x1F, 0x0A43);
                 MP_WritePhyUshort(sc, 0x13, 0x809b);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xF800 ,
+                                     0xF800,
                                      0x8000
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80A2);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x8000
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80A4);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x8500
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x809C);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xbd00
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21677,19 +25344,19 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x13, 0x80AD);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xF800 ,
+                                     0xF800,
                                      0x7000
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80B4);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x5000
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x80AC);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x4000
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21698,19 +25365,19 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x13, 0x808E);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x1200
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x8090);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0xE500
                                     );
                 MP_WritePhyUshort(sc, 0x13, 0x8092);
                 ClearAndSetEthPhyBit(sc,
                                      0x14,
-                                     0xFF00 ,
+                                     0xFF00,
                                      0x9F00
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21777,7 +25444,7 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x1F, 0x0BCA);
                 ClearAndSetEthPhyBit(sc,
                                      0x17,
-                                     (BIT_13 | BIT_12) ,
+                                     (BIT_13 | BIT_12),
                                      BIT_14
                                     );
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
@@ -21811,78 +25478,18 @@ static void re_hw_phy_config(struct re_softc *sc)
                 }
 
                 MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                MP_WritePhyUshort(sc, 0x13, 0x8045);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x804d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x805d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
                 MP_WritePhyUshort(sc, 0x13, 0x8011);
-                ClearEthPhyBit(sc, 0x14, BIT_15);
+                SetEthPhyBit(sc, 0x14, BIT_15);
                 MP_WritePhyUshort(sc, 0x1F, 0x0A40);
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
                 MP_WritePhyUshort(sc, 0x00, 0x9200);
         } else if (sc->re_type == MACFG_69) {
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                PhyRegValue |= BIT_4;
-                MP_WritePhyUshort(sc,0x10, PhyRegValue);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0B80);
-                WaitCnt = 0;
-                do {
-                        PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                        PhyRegValue &= 0x0040;
-                        DELAY(50);
-                        DELAY(50);
-                        WaitCnt++;
-                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x8028);
-                MP_WritePhyUshort(sc,0x14, 0x6201);
-                MP_WritePhyUshort(sc,0x13, 0xB82E);
-                MP_WritePhyUshort(sc,0x14, 0x0001);
-
-                MP_WritePhyUshort(sc, 0x1F, 0x0A43);
-                MP_WritePhyUshort(sc, 0x13, 0xB820);
-                MP_WritePhyUshort(sc, 0x14, 0x0290);
-                MP_WritePhyUshort(sc, 0x13, 0xA012);
-                MP_WritePhyUshort(sc, 0x14, 0x0000);
-                MP_WritePhyUshort(sc, 0x13, 0xA014);
-                MP_WritePhyUshort(sc, 0x14, 0x2c04);
-                MP_WritePhyUshort(sc, 0x14, 0x2c09);
-                MP_WritePhyUshort(sc, 0x14, 0x2c09);
-                MP_WritePhyUshort(sc, 0x14, 0x2c09);
-                MP_WritePhyUshort(sc, 0x14, 0xad01);
-                MP_WritePhyUshort(sc, 0x14, 0xad01);
-                MP_WritePhyUshort(sc, 0x14, 0xad01);
-                MP_WritePhyUshort(sc, 0x14, 0xad01);
-                MP_WritePhyUshort(sc, 0x14, 0x236c);
-                MP_WritePhyUshort(sc, 0x13, 0xA01A);
-                MP_WritePhyUshort(sc, 0x14, 0x0000);
-                MP_WritePhyUshort(sc, 0x13, 0xA006);
-                MP_WritePhyUshort(sc, 0x14, 0x0fff);
-                MP_WritePhyUshort(sc, 0x13, 0xA004);
-                MP_WritePhyUshort(sc, 0x14, 0x0fff);
-                MP_WritePhyUshort(sc, 0x13, 0xA002);
-                MP_WritePhyUshort(sc, 0x14, 0x0fff);
-                MP_WritePhyUshort(sc, 0x13, 0xA000);
-                MP_WritePhyUshort(sc, 0x14, 0x136b);
-                MP_WritePhyUshort(sc, 0x13, 0xB820);
-                MP_WritePhyUshort(sc, 0x14, 0x0210);
-
-                MP_WritePhyUshort(sc,0x1F, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x0000);
-                MP_WritePhyUshort(sc,0x14, 0x0000);
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x17);
-                PhyRegValue &= ~(BIT_0);
-                MP_WritePhyUshort(sc,0x17, PhyRegValue);
-                MP_WritePhyUshort(sc,0x1f, 0x0A43);
-                MP_WritePhyUshort(sc,0x13, 0x8028);
-                MP_WritePhyUshort(sc,0x14, 0x0000);
-
-                MP_WritePhyUshort(sc,0x1f, 0x0B82);
-                PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
-                PhyRegValue &= ~(BIT_4);
-                MP_WritePhyUshort(sc,0x10, PhyRegValue);
-
-
                 MP_WritePhyUshort(sc, 0x1F, 0x0A43);
                 MP_WritePhyUshort(sc, 0x13, 0x808A);
                 ClearAndSetEthPhyBit(sc,
@@ -21938,8 +25545,179 @@ static void re_hw_phy_config(struct re_softc *sc)
                 }
 
                 MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                MP_WritePhyUshort(sc, 0x13, 0x8045);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x804d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x805d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x8011);
+                SetEthPhyBit(sc, 0x14, BIT_15);
+                MP_WritePhyUshort(sc, 0x1F, 0x0A40);
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+                MP_WritePhyUshort(sc, 0x00, 0x9200);
+        }  else if (sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
+                MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                MP_WritePhyUshort(sc, 0x13, 0x808E);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x4000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x8090);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0xCC00
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x8092);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0xB000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x8088);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x8000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x808B);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x3F00,
+                                      0x0B00
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x808D);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x1F00,
+                                      0x0600
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x808C);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0xB000
+                                    );
+
+                MP_WritePhyUshort(sc, 0x13, 0x80A0);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x2000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80A2);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x5000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x809B);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xF800,
+                                      0xB000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x809A);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x4B00
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x809D);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x3F00,
+                                      0x0800
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80A1);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x7000
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x809F);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x1F00,
+                                      0x0300
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x809E);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x8800
+                                    );
+
+                MP_WritePhyUshort(sc, 0x13, 0x80B2);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x2200
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80AD);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xF800,
+                                      0x9800
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80AF);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x3F00,
+                                      0x0800
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80B3);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x6F00
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80B1);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0x1F00,
+                                      0x0300
+                                    );
+                MP_WritePhyUshort(sc, 0x13, 0x80B0);
+                ClearAndSetEthPhyBit( sc,
+                                      0x14,
+                                      0xFF00,
+                                      0x9300
+                                    );
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+
+                MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                MP_WritePhyUshort(sc, 0x13, 0x8011);
+                SetEthPhyBit(sc, 0x14, BIT_11);
+                MP_WritePhyUshort(sc, 0x1F, 0x0A42);
+                SetEthPhyBit(sc, 0x16, BIT_1);
+
+                MP_WritePhyUshort(sc, 0x1F, 0x0A44);
+                SetEthPhyBit( sc, 0x11, BIT_11 );
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+
+                if (phy_power_saving == 1) {
+                        MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                        SetEthPhyBit(sc, 0x10, BIT_2);
+                        MP_WritePhyUshort(sc, 0x1F, 0x0000);
+                } else {
+                        MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                        ClearEthPhyBit(sc, 0x10, BIT_2);
+                        MP_WritePhyUshort(sc, 0x1F, 0x0000);
+                        DELAY(20000);
+                }
+
+                MP_WritePhyUshort(sc, 0x1F, 0x0A43);
+                MP_WritePhyUshort(sc, 0x13, 0x8045);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x804d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
+                MP_WritePhyUshort(sc, 0x13, 0x805d);
+                MP_WritePhyUshort(sc, 0x14, 0x2444);
                 MP_WritePhyUshort(sc, 0x13, 0x8011);
-                ClearEthPhyBit(sc, 0x14, BIT_15);
+                SetEthPhyBit(sc, 0x14, BIT_15);
                 MP_WritePhyUshort(sc, 0x1F, 0x0A40);
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
                 MP_WritePhyUshort(sc, 0x00, 0x9200);
@@ -21977,6 +25755,8 @@ static void re_hw_phy_config(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 if (phy_mdix_mode == RE_ETH_PHY_FORCE_MDI) {
                         //Force MDI
                         MP_WritePhyUshort(sc, 0x1F, 0x0A43);
@@ -22001,7 +25781,8 @@ static void re_hw_phy_config(struct re_softc *sc)
         if (phy_power_saving == 1) {
                 if (sc->re_type == MACFG_59 || sc->re_type == MACFG_60 ||
                     sc->re_type == MACFG_62 || sc->re_type == MACFG_67 ||
-                    sc->re_type == MACFG_68 || sc->re_type == MACFG_69) {
+                    sc->re_type == MACFG_68 || sc->re_type == MACFG_69 ||
+                    sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
                         MP_WritePhyOcpRegWord(sc, 0x0C41, 0x13, 0x0000);
                         MP_WritePhyOcpRegWord(sc, 0x0C41, 0x13, 0x0050);
                 }
@@ -22041,7 +25822,8 @@ void MP_WritePhyUshort(struct re_softc *sc,u_int8_t RegAddr,u_int16_t RegData)
                    sc->re_type == MACFG_58 || sc->re_type == MACFG_59 ||
                    sc->re_type == MACFG_60 || sc->re_type == MACFG_61 ||
                    sc->re_type == MACFG_62 || sc->re_type == MACFG_67 ||
-                   sc->re_type == MACFG_69 || sc->re_type == MACFG_69) {
+                   sc->re_type == MACFG_69 || sc->re_type == MACFG_69 ||
+                   sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
                 if (RegAddr == 0x1F) {
                         return;
                 }
@@ -22049,7 +25831,7 @@ void MP_WritePhyUshort(struct re_softc *sc,u_int8_t RegAddr,u_int16_t RegData)
                 MP_WritePhyOcpRegWord(sc, sc->cur_page, RegAddr, RegData);
         } else {
                 if (sc->re_type == MACFG_65 || sc->re_type == MACFG_66)
-                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc,0xD0) & ~0x00020000);
+                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc, 0xD0) & ~0x00020000);
 
                 TmpUlong |= (((u_int32_t)RegAddr)<<16 | (u_int32_t)RegData);
 
@@ -22063,7 +25845,7 @@ void MP_WritePhyUshort(struct re_softc *sc,u_int8_t RegAddr,u_int16_t RegData)
                 }
 
                 if (sc->re_type == MACFG_65 || sc->re_type == MACFG_66)
-                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc,0xD0) | 0x00020000);
+                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc, 0xD0) | 0x00020000);
         }
 }
 
@@ -22101,12 +25883,13 @@ u_int16_t MP_ReadPhyUshort(struct re_softc *sc,u_int8_t RegAddr)
                    sc->re_type == MACFG_58 || sc->re_type == MACFG_59 ||
                    sc->re_type == MACFG_60 || sc->re_type == MACFG_61 ||
                    sc->re_type == MACFG_62 || sc->re_type == MACFG_67 ||
-                   sc->re_type == MACFG_69 || sc->re_type == MACFG_69) {
+                   sc->re_type == MACFG_69 || sc->re_type == MACFG_69 ||
+                   sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
                 RegData= MP_ReadPhyOcpRegWord(sc, sc->cur_page, RegAddr);
 
         } else {
                 if (sc->re_type == MACFG_65 || sc->re_type == MACFG_66)
-                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc,0xD0) & ~0x00020000);
+                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc, 0xD0) & ~0x00020000);
 
                 TmpUlong = ((u_int32_t)RegAddr << 16);
                 CSR_WRITE_4(sc, RE_PHYAR, TmpUlong);
